//---------------------------------------------------------------------------
#ifndef ledScrollerH
#define ledScrollerH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TScrollThread;
//---------------------------------------------------------------------------
class PACKAGE TLedScroller : public TCustomControl
{
  friend TScrollThread;
private:
  bool FActive;
  TFont *FFont;
  int FBottomEdge;
  int FRightEdge;
  bool FScrolled;
  int FScrollTimer;
  Graphics::TBitmap *FImageLedOn;
  Graphics::TBitmap *FImageLedOff;
  AnsiString FText;
  bool FTransparentBitmaps;
  bool FUseFont;
  void __fastcall SetActive(bool Value);
  void __fastcall SetFont(TFont *Value);
  void __fastcall SetBottomEdge(int Value);
  void __fastcall SetRightEdge(int Value);
  void __fastcall SetImageLedOn(Graphics::TBitmap *Value);
  void __fastcall SetImageLedOff(Graphics::TBitmap *Value);
  void __fastcall SetScrolled(bool Value);
  void __fastcall SetText(AnsiString Value);
  void __fastcall SetTransparentBitmaps(bool Value);
protected:
  Graphics::TBitmap *scrollBitmap;
  TScrollThread *scrollThread;
  int lWidth, lHeight;
  void __fastcall RenderScrollBitmap(void);
  void __fastcall WMSize(TMessage &Message);
    BEGIN_MESSAGE_MAP
      MESSAGE_HANDLER(WM_SIZE,TMessage,WMSize)
    END_MESSAGE_MAP(TCustomControl)
public:
  __fastcall TLedScroller(TComponent* Owner);
  virtual __fastcall ~TLedScroller();
  virtual void __fastcall Paint(void);
__published:
  __property Align;
  __property Color;
  __property ParentColor;
  __property Visible;
  __property bool Active = {read = FActive, write = SetActive};
  __property TFont *Font = {read = FFont, write = SetFont};
  __property int BottomEdge = {read = FBottomEdge, write = SetBottomEdge, default = 1};
  __property int RightEdge = {read = FRightEdge, write = SetRightEdge, default = 1};
  __property Graphics::TBitmap *ImageLedOn = {read = FImageLedOn, write = SetImageLedOn};
  __property Graphics::TBitmap *ImageLedOff = {read = FImageLedOff, write = SetImageLedOff};
  __property bool Scrolled = {read = FScrolled, write = SetScrolled};
  __property int ScrollTimer = {read = FScrollTimer, write = FScrollTimer, default = 100};
  __property AnsiString Text = {read = FText, write = SetText};
  __property bool TransparentBitmaps = {read = FTransparentBitmaps, write = SetTransparentBitmaps};
};
//---------------------------------------------------------------------------
#endif
